/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pb138.cv3.domtask;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author bar
 */
public class DOMTask {
    private Document doc;
    
    public DOMTask(String filename) throws ParserConfigurationException, SAXException, IOException {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
        DocumentBuilder db = dbf.newDocumentBuilder();
        doc = db.parse(filename);
    }
    
    /**
     * Calculates average grade for each student. Result adds as the child element
     * average to the element student
     */
    public void calculateAveragePerStudent() {
        NodeList students = doc.getElementsByTagName("student");
        for(int i=0;i<students.getLength();i++){
            Element studentElement = (Element)students.item(i);
            double avg = calculateAverage(studentElement);
            addAverage(studentElement,avg);
        }
        
    }
    
    /**
     * Calculates total absence for the class and the result adds as the attribute
     * total_absence to the element class.
     */
    private void calculateTotalAbsence() {
        NodeList students = doc.getElementsByTagName("student");
        int absence = 0;
        for(int i=0 ; i<students.getLength() ; i++){
            Element absenceElement = (Element)students.item(i);
            String attrValue =absenceElement.getAttribute("absence");
            if(attrValue!=null && !attrValue.isEmpty()){
                int absCount = Integer.parseInt(absenceElement.getAttribute("absence"));
                absence += absCount;
            }
            
        }
        addAbsenceToClass(absence);
    }

    private boolean addAbsenceToClass(int absence) throws DOMException {
        NodeList classes = doc.getElementsByTagName("class");
        if (classes.getLength()<=0) {
            System.err.println("No class element");
            return true;
        }
        Element classElement =(Element)classes.item(0);
        classElement.setAttribute("total_absence", absence+"");
        return false;
    }
    
    private void store(String filename) throws TransformerConfigurationException, TransformerException {
        TransformerFactory tf = TransformerFactory.newInstance();
        Transformer trans = tf.newTransformer();
        trans.transform(new DOMSource(doc), new StreamResult(filename));
        
    }
    
    public static void main(String[] args) throws ParserConfigurationException, SAXException, IOException, TransformerConfigurationException, TransformerException {
        DOMTask task = new DOMTask("grades.xml");
        task.calculateAveragePerStudent();
        task.store("grades-avg.xml");
        //task.calculateTotalAbsence();
        task.calculateTotalAbsenceXP();
        task.store("grades-absence.xml");
    }

    private void calculateTotalAbsenceXP() {
        XPathFactory xpf = XPathFactory.newInstance();
        XPath xPath = xpf.newXPath();
        
        try {
            double totalAbsence = (double) xPath.evaluate("sum(//student/@absence)", doc, XPathConstants.NUMBER);
            addAbsenceToClass((int)totalAbsence);
        } catch (XPathExpressionException ex) {
            Logger.getLogger(DOMTask.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        
    }

    private double calculateAverage(Element studentElement) {
        XPathFactory xpf = XPathFactory.newInstance();
        XPath xPath = xpf.newXPath();
        try {
            double sum = (double) xPath.evaluate("sum(./course)", studentElement,XPathConstants.NUMBER);
            double count = (double)xPath.evaluate("count(./course)", studentElement,XPathConstants.NUMBER);
            return sum/count;
        } catch (XPathExpressionException ex) {
            Logger.getLogger(DOMTask.class.getName()).log(Level.SEVERE, null, ex);
        }
        return -1.0;
    }

    private void addAverage(Element studentElement, double avg) {
        Element average = doc.createElement("average");
        average.setTextContent(avg+"");
        studentElement.appendChild(average);
        
    }

    

    

    

    
}
